<?php
/**
* @Copyright Copyright (C) 2010 VTEM . All rights reserved.
* @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
* @link     	http://www.vtem.net
**/

// no direct access
defined( '_JEXEC' ) or die('Restricted access');

class modVtemTabsHelper{
    public static function getLists($params){
        global $mainframe;
		
        $db         = JFactory::getDBO();
        $user       = JFactory::getUser();
        $userId     =  (int) $user->get('id');
        $aid        =  $user->get('aid', 0);
        $nullDate   =  $db->getNullDate();
        $date       = JFactory::getDate();
        $now        =  $date->toMySQL();
		$app = JFactory::getApplication();
		$user_id = $params->get('user_id');
        
        $content_source = $params->get('content_source','mods');
        //joomla specific
        if($content_source == 'joomla'){
			 require_once JPATH_SITE.'/components/com_content/router.php';
			 require_once JPATH_SITE.'/components/com_content/helpers/route.php';
				// Get an instance of the generic articles model
				$articles = JModel::getInstance('Articles', 'ContentModel', array('ignore_request' => true));
				// Set application parameters in model
				$appParams = $app->getParams();
				$articles->setState('params', $appParams);
				// Set the filters based on the module params
				$articles->setState('list.start', 0);
				$articles->setState('list.limit', (int) $params->get('tabs_count', 3));
				$articles->setState('filter.published', 1);
				// Access filter
				$access = !JComponentHelper::getParams('com_content')->get('show_noauth');
				$authorised = JAccess::getAuthorisedViewLevels(JFactory::getUser()->get('id'));
				$articles->setState('filter.access', $access);
				$catids = $params->get('catid');
				$articles->setState('filter.category_id.include', (bool) $params->get('category_filtering_type', 1));
				// Category filter
				if ($catids) {
				 if ($params->get('show_child_category_articles', 0) && (int) $params->get('levels', 0) > 0) {
					// Get an instance of the generic categories model
					$categories = JModel::getInstance('Categories', 'ContentModel', array('ignore_request' => true));
					$categories->setState('params', $appParams);
					$levels = $params->get('levels', 1) ? $params->get('levels', 1) : 9999;
					$categories->setState('filter.get_children', $levels);
					$categories->setState('filter.published', 1);
					$categories->setState('filter.access', $access);
					$additional_catids = array();
	
					foreach($catids as $catid)
					{
						$categories->setState('filter.parentId', $catid);
						$recursive = true;
						$items = $categories->getItems($recursive);
	
						if ($items)
						{
							foreach($items as $category)
							{
								$condition = (($category->level - $categories->getParent()->level) <= $levels);
								if ($condition) {
									$additional_catids[] = $category->id;
								}
	
							}
						}
					}
	
					$catids = array_unique(array_merge($catids, $additional_catids));
				 }
	
				$articles->setState('filter.category_id', $catids);
			  }
			// Ordering
			$articles->setState('list.ordering', $params->get('article_ordering', 'a.ordering'));
			$articles->setState('list.direction', $params->get('article_ordering_direction', 'ASC'));
			// New Parameters
			$articles->setState('filter.featured', $params->get('show_front', 'show'));
			$articles->setState('filter.author_id', $params->get('created_by', ""));
			$articles->setState('filter.author_id.include', $params->get('author_filtering_type', 1));
			$article_filtering_type = $params->get('article_filtering_type', 1);
			$article_ids = $params->get('article_ids', '');
			if($article_filtering_type == 1){
			  if ($article_ids) {
				$article_ids = explode(",", $article_ids);
				$articles->setState('filter.article_id', $article_ids);
				$articles->setState('filter.article_id.include', true); 
			  }
			}else{
				$article_ids = explode(",", $article_ids);
				$articles->setState('filter.article_id', $article_ids);
				$articles->setState('filter.article_id.include', false); 
			}
			$items = $articles->getItems();
	
			// Prepare data for display using display options
			$i = 0;
			$lists = array();
			foreach ($items as &$item)
			{
					$item->slug = $item->id.':'.$item->alias;
					$item->catslug = $item->catid ? $item->catid .':'.$item->category_alias : $item->catid;
	
					if ($access || in_array($item->access, $authorised)) {
						// We know that user has the privilege to view the article
						$lists[$i]->link = JRoute::_(ContentHelperRoute::getArticleRoute($item->slug, $item->catslug));
					}
					 else {
					// Angie Fixed Routing
					$menu	= $app->getMenu();
					$menuitems	= $menu->getItems('link', 'index.php?option=com_users&view=login');
				    if(isset($menuitems[0])) {
						$Itemid = $menuitems[0]->id;
					} else if (JRequest::getInt('Itemid') > 0) { //use Itemid from requesting page only if there is no existing menu
						$Itemid = JRequest::getInt('Itemid');
					}
	
					$lists[$i]->link = JRoute::_('index.php?option=com_users&view=login&Itemid='.$Itemid);
					}
					$lists[$i]->title = $item->title;
					$lists[$i]->introtext = JHtml::_('content.prepare', $item->introtext);
				    if ($params->get('show_readmore')) :
 				  		$lists[$i]->introtext .= '<a class="vtem-tabs-readon" href="'.$lists[$i]->link.'"><span>';
                    	if ($readmore = $params->get('readmore')) :
                        	$lists[$i]->introtext .= $readmore;
                        else :
                      	    $lists[$i]->introtext .= JText::sprintf('Read more...');
                        endif;
					    $lists[$i]->introtext .= '</span></a>';
			        endif;
				   $i++;
			}
			return $lists;
        }else if($content_source == 'k2'){
			   // start K2 specific
				require_once(JPATH_SITE . DS . 'components' . DS . 'com_k2' . DS . 'models' . DS . 'itemlist.php');
				require_once(JPATH_SITE . DS . 'components' . DS . 'com_k2' . DS . 'helpers' . DS . 'route.php');
				require_once(JPATH_SITE . DS . 'components' . DS . 'com_k2' . DS . 'helpers' . DS . 'utilities.php');
	
				//Initialize Variables
				$k2_category = $params->get('k2_category', array());
				$k2_children = $params->get('k2_children', 0);
				$k2_ordering = $params->get('k2_ordering', 'a.title');
				$k2_featured = $params->get('k2_featured', 1);
				$k2_image_size = $params->get('k2_image_size', 'M');
				$query = "SELECT a.*, c.name AS categoryname,c.id AS categoryid, c.alias AS categoryalias, c.params AS categoryparams";
				$query .= " FROM #__k2_items as a LEFT JOIN #__k2_categories c ON c.id = a.catid";
				$query .= " WHERE a.published = 1 AND a.access IN(" . implode(',', $user->authorisedLevels()) . ") AND a.trash = 0 AND c.published = 1 AND c.access IN(" . implode(',', $user->authorisedLevels()) . ")  AND c.trash = 0";
				//User Filter
				switch ($user_id){
					case 'by_me':
						$query .= ' AND (a.created_by = ' . (int)$userId . ' OR a.modified_by = ' . (int)$userId . ')';
						break;
					case 'not_me':
						$query .= ' AND (a.created_by <> ' . (int)$userId . ' AND a.modified_by <> ' . (int)$userId . ')';
						break;
				}
	
				$query .= " AND ( a.publish_up = " . $db->Quote($nullDate) . " OR a.publish_up <= " . $db->Quote($now) . " )";
				$query .= " AND ( a.publish_down = " . $db->Quote($nullDate) . " OR a.publish_down >= " . $db->Quote($now) . " )";
	
				if (!is_null($k2_category)) {
					if (is_array($k2_category)) {
						if ($k2_children) {
							require_once (JPATH_SITE . DS . 'components' . DS . 'com_k2' . DS . 'models' . DS . 'itemlist.php');
							$categories = K2ModelItemlist::getCategoryTree($k2_category);
							$sql = @implode(',', $categories);
							$query .= " AND a.catid IN ({$sql})";
	
						} else {
							JArrayHelper::toInteger($k2_category);
							$query .= " AND a.catid IN(" . implode(',', $k2_category) . ")";
						}
	
					} else {
						if ($k2_children) {
							require_once (JPATH_SITE . DS . 'components' . DS . 'com_k2' . DS . 'models' . DS . 'itemlist.php');
							$categories = K2ModelItemlist::getCategoryTree($k2_category);
							$sql = @implode(',', $categories);
							$query .= " AND a.catid IN ({$sql})";
						} else {
							$query .= " AND a.catid=" . (int)$k2_category;
						}
	
					}
				}
	
				if ($k2_featured == '0')
					$query .= " AND a.featured != 1";
	
				if ($k2_featured == '2')
					$query .= " AND a.featured = 1";
	
				if ($app->getLanguageFilter()) {
					$languageTag = JFactory::getLanguage()->getTag();
					$query .= " AND c.language IN (" . $db->Quote($languageTag) . ", " . $db->Quote('*') . ") AND a.language IN (" . $db->Quote($languageTag) . ", " . $db->Quote('*') . ")";
				}
	
				// ordering
				$ordering = $params->get('itemsOrdering');
				switch ($ordering) {
					case 'date' :
						$orderby = 'a.created ASC';
						break;
					case 'rdate' :
						$orderby = 'a.created DESC';
						break;
					case 'alpha' :
						$orderby = 'a.title';
						break;
					case 'ralpha' :
						$orderby = 'a.title DESC';
						break;
					case 'order':
						if ($k2_featured == '2')
							$orderby = 'a.featured_ordering';
						else
							$orderby = 'a.ordering';
						break;
					case 'random' :
						$orderby = 'RAND()';
						break;
					default :
						$orderby = 'a.id DESC';
						break;
				}
	
				$query .= " ORDER BY " . $orderby;
				$db->setQuery($query, 0, $params->get('tabs_count', 3));
				$items = $db->loadObjectList();
				$i = 0;
				$lists = array();
				foreach ($items as $item)
				{
				  $lists[$i]->id = $item->id;
				  $link = JRoute::_(K2HelperRoute::getItemRoute($item->id, $item->catid));
				  $readmore_register = false;
                  $images = self::getK2Images($item->id, $k2_image_size);
				  $lists[$i]->link = $link;
                  $lists[$i]->readmore_register = $readmore_register;
				  if ($images) {
                     $lists[$i]->image = $images->image;
                  } else {
                   $lists[$i]->image = '';
				  }
				  $lists[$i]->title = htmlspecialchars($item->title);
				  $lists[$i]->introtext = '<img src="'.$lists[$i]->image.'" alt="'.$lists[$i]->title.'"/>';
				  $lists[$i]->introtext .= $item->introtext;
				  if ($params->get('show_k2readmore')) :
					  $lists[$i]->introtext .= '<a href="'.$lists[$i]->link.'" class="vtem-tabs-readon"><span>';
						 if ($lists[$i]->readmore_register) :
							$lists[$i]->introtext .= JText::_('Register to read more...');
						  elseif ($readmore = $params->get('k2readmore')) :
							 $lists[$i]->introtext .= $readmore;
						  else :
							$lists[$i]->introtext .= JText::sprintf('Read more...');
						  endif;
					  $lists[$i]->introtext .= '</span></a>';
				  endif;
				  $i++;
				}
				return $lists;
        }else{
				//module specific
				if (trim($params->get('sortModuleManual')) != "")
					$mods = explode(",", $params->get('sortModuleManual'));
				else
					$mods = $params->get('modules');
				$options 	= array('style' => 'none');
				$lists = array();
				if(count($mods) > 1){
				 for($i=0; $i<count($mods); $i++){
					$lists[$i]->order 	= modVtemTabsHelper::getModule($mods[$i])->ordering;
					$lists[$i]->title 	= modVtemTabsHelper::getModule($mods[$i])->title;
					$lists[$i]->introtext = JModuleHelper::renderModule(modVtemTabsHelper::getModule($mods[$i]), $options);
				 }
				}else{
					$lists[0]->order 	= modVtemTabsHelper::getModule($mods)->ordering;
					$lists[0]->title 	= modVtemTabsHelper::getModule($mods)->title;
					$lists[0]->introtext = JModuleHelper::renderModule(modVtemTabsHelper::getModule($mods), $options);
				}
				return $lists;
        }
    }
	
    //fetch module by id
    public static function getModule($id){
		$db		= JFactory::getDBO();
		$where = ' AND ( m.id='.$id.' ) ';
		$query = 'SELECT *'.
			' FROM #__modules AS m'.
			' WHERE m.client_id = 0'.
			$where.
			' ORDER BY ordering'.
			' LIMIT 1';
		$db->setQuery( $query );
		$module = $db->loadObject();
		if (!$module) return null;
		$file				= $module->module;
		$custom				= substr($file, 0, 4) == 'mod_' ?  0 : 1;
		$module->user		= $custom;
		$module->name		= $custom ? $module->title : substr($file, 4);
		$module->style		= null;
		$module->position	= strtolower($module->position);
		$clean[$module->id]	= $module;
		return $module;
	}
		
    public static function generateTabs($tabs, $list, $params){
        $title_type = $params->get('tabs_title_type');
        $position = $params->get('tabs_position','top');
        if($title_type == 'custom'){
            $titles = explode(";",$params->get('tabs_title_custom'));
        }
        if($tabs == 0 OR $tabs>count($list)) $tabs = count($list);
        $html  = "<div class='clearfix vtemtabs-nav vtemtabs-nav-$position'>";
        $html .= "<ul class='vtemtabsnav oTabs'>";
        for($i=0; $i<$tabs; $i++){
            $class = '';
            if($list[$i]->introtext != NULL){
                if(!$i) $class= 'first';
                if($i == $tabs - 1) $class= 'last';
                if($title_type == 'custom') $title = (isset($titles[$i])) ? $titles[$i] : '';
                else $title = $list[$i]->title;
                $html .= "<li class='$class'><a href='#'><span>$title</span><strong>&nbsp;</strong></a></li>\n";
            }
        }
        $html .= "</ul>\n";
        $html .= "</div>";
        return $html;  
    }

    public static function getK2Images($id, $image_size){
        if (file_exists(JPATH_SITE . DS . 'media' . DS . 'k2' . DS . 'items' . DS . 'cache' . DS . md5("Image" . $id) . '_' . $image_size . '.jpg')) {
            $image_path = 'media/k2/items/cache/' . md5("Image" . $id) . '_' . $image_size . '.jpg';
            $images->image = JURI::Root(true) . '/' . $image_path;
            return $images;
        }
    }
}